﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace XTX.parser
{
    class Pare<X, Y>
    {
        public X x;
        public Y y;

        public Pare() { }

        public Pare(X _x, Y _y)
        {
            x = _x;
            y = _y;
        }

        public override bool Equals(object obj)
        {
            if (obj is Pare<X, Y>)
            {
                Pare<X, Y> o = (Pare<X, Y>)obj;
                return equals(o.x, x) && equals(o.y, y);
            }
            else
                return false;
        }

        public override int GetHashCode()
        {
            return summ(hashcode(x), hashcode(y));
        }

        private int summ(int a, int b)
        {
            unchecked
            {
                return a + b;
            }
        }

        private int hashcode(object z)
        {
            if (z == null)
                return 0;
            else
                return z.GetHashCode();
        }

        private bool equals(object a, object b)
        {
            if (a == null && b == null)
                return true;
            else if (a == null || b == null)
                return false;
            else
                return a.Equals(b);
        }
    }
}
